;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Border
;
; PRINT USR BRDR;"Sequence"]
;
;================================


@DFile=400C		;Start of DFile

@Border
	RST 20 		;Skip ;
	LD A,75
	INC A
	CP (HL)
	JR NZ Bord01	;Jump if not N/L
	LD HL,000C	;Offset to border sequence
	ADD HL,BC	;Note, BC=USR address
	JR Bord01
;Border sequence
	07 03 84 85 81 83 82 05
@Bord01
	INC HL
	EX DE,HL
	LD HL,(DFile)
	INC HL
	LD A,(DE)	;NW corner
	LD (HL),A
	INC DE
	INC HL
	LD A,(DE)	;Top row
	LD (HL),A
	PUSH DE
	LD D,H
	LD E,L
	INC DE
	LD BC,001D
	LDIR
	EX DE,HL
	POP DE
	INC DE
	LD A,(DE)	;NE corner
	LD (HL),A
	INC DE
	LD A,(DE)	;Rite edge
	PUSH DE
	LD DE,0021
	LD B,17
	ADD HL,DE
	LD (HL),A
	DJNZ -4
	POP DE
	INC DE
	LD A,(DE)	;SE corner
	LD (HL),A
	INC DE
	DEC HL
	LD A,(DE)	;Bottom row
	LD (HL),A
	PUSH DE
	LD D,H
	LD E,L
	DEC DE
	LD C,1D
	LDDR
	EX DE,HL
	POP DE
	INC DE
	LD A,(DE)	;SW corner
	LD (HL),A
	INC DE
	LD A,(DE)	;Left edge
	LD DE,0021
	LD B,16
	SBC HL,DE
	LD (HL),A
	DJNZ -5
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF
