@DFile=400C
@CHADD=4016		;Address of next character
@Vars=4010
@Report2=0D4B
@NextOne=09F2


ORG 4082

	LD HL,(CHADD)	;Get current chr. address
	INC HL		;Skip THEN
	INC HL		;Skip REM
	LD A,(HL)	;Get String Var chr
	ADD A,20
@FindStr
	LD C,A		;C=Chr code+32
@FindVar
	LD HL,(Vars)	;Get start of Vars
@NextVar
	LD A,(HL) 	;Get var
	CP C		;Match?
	JR Z Found 	;Jump if match
	CP 80 		;End of Vars?
	JP Z Report2	;Jump if variable not found
	PUSH BC		;PUSH string id
	CALL NextOne	;Locate next variable
	POP BC		;POP string id
	EX DE,HL
	JR NextVar
@Found
	INC HL		;Skip var header
	INC HL
@Loop
	INC HL		;Start of HLIN data
	LD A,(HL)	;Get Ycoord
	SUB 1C		;Convert Ycoord to digit
	LD B,A		;B=Ycoord, 0 to 23
	INC HL		;Xcoord
	LD A,(HL)	;Get Xcoord
	SUB 1C		;Convert Xcoord to digit
	LD C,A		;C=Xcoord, 0 to 31
	INC HL
	PUSH HL		;PUSH CHADD
	LD HL,(DFile)	;Get DFile
	INC HL
	LD A,B		;Test for Ycoord=0
	AND A
	JR Z +6		;Jump if Ycoord=0
	LD DE,0021	;Bytes/row
	ADD HL,DE	;Add row offset
	DJNZ -3
	ADD HL,BC	;Add column offset
	POP DE		;POP CHADD
	LD A,(DE)	;Get length chr.
	SUB 1C		;Convert length chr. to digit
	LD C,A		;BC=Length
	INC DE		;Chr. to print addr
	LD A,(DE)	;Get chr. to print
	LD (HL),A	;Set chr to print
	DEC C
	PUSH DE		;PUSH CHADD
	JR Z More	;Jump if chr count=1
	LD D,H		;Setup for LDIR
	LD E,L
	INC DE
	LDIR
@More
	POP HL		;POP CHADD
	INC HL		;Next CHADD
	LD A,(HL)	;Get next chr.
	CP 0E		;Test for ":"
	RET NZ		;If not ":" then return to BASIC, BC=0
	JR Loop 	;Loop if chr=":"