;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Invert screen
;
; PRINT USR INV;[Count]
;
;================================

@DFile=400C		;DFile address
@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackA=0C02		;Move results to A

@Invert
	RST 20		;Get next character
	LD B,01		;Default flash count
	LD A,75
	INC A
	CP (HL)
	JR Z Outer	;Jump if no value specified
	CALL Class6	;Evaluate [Count] expression
	CALL StackA	;Move results to A, A=Count
	LD B,A		;B=Count
@Outer
	LD DE,0300	;DFile size 
	LD HL,(DFile)	;Get DFile
@Inner
	INC HL		;Next DFile	
	LD A,(HL)	;Get DFile chr
	BIT 6,A		;N/L?
	JR NZ Inner	;Jump if N/L
	ADD A,80	;Invert chr by adding 128
	LD (HL),A	;Replace DFile chr with inverted chr
	DEC DE 		;Decrease counter
	LD A,D 
	OR E
	JR NZ Inner	;Loop until DE=0
	DJNZ Outer	;Loop until B=0
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF
