;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Replace Chr A with Chr B
;
; PRINT USR REPL;[CODE "Chr A"],[CODE "Chr B"]
;
;================================

@DFile=400C		;Start of DFile
@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackBC=0BF5		;Move results to BC

@Replace
	RST 20		;Get next character
	CALL Class6	;Evaluate [CODE "Chr A"] expression
	RST 20 		;Get next character
	CALL Class6	;Evaluate [CODE "Chr B"] expression
	CALL StackBC	;Move results to BC, B=Chr B, A=C=Chr A
	LD E,B		;E=Chr. B
	LD HL,(DFile)	;Get DFile
	LD BC,0319	;DFile size
@Loop
	CPIR		;Search for Chr A
	JP PO 0008	;Return via Error Restart, skipping the PRINT routine
	DEC HL		;Backup 1 byte
	LD (HL),E	;Replace Chr A with Chr B
	INC HL		;Restore DFile pointer
	JR Loop		;Loop until DE=0