;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Roll Left
;
; PRINT USR RLFT;[Lines]
;
;================================

@DFile=400C		;Start of DFile
@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackA=0C02		;Move results to A

@RollLeft
	RST 20		;Get next character
	LD B,01		;Default lines
	LD A,75
	INC A
	CP (HL)
	JR Z Outer	;Jump if no value specified
	CALL Class6	;Evaluate [Lines] expression
	CALL StackA	;Move results to A, A=Lines
	LD B,A		;B=Lines
@Outer
	PUSH BC		;PUSH roll counter
	LD HL,(DFile)	;Get DFile
	INC HL
	LD B,18		;Row counter
@Inner
	PUSH BC		;PUSH row counter
	PUSH HL		;PUSH column 0 addr
	LD A,(HL)	;Get column 0 chr
;Shift row right
	INC HL		;Setup for LDIR
	LD D,H
	LD E,L
	DEC DE
	LD BC,001F
	LDIR
	LD (DE),A	;Fill column 31 with column 0 chr
	POP HL		;POP column 0 addr
	LD C,21		;Offset to next row
	ADD HL,BC	;Start of next row
	POP BC		;POP row counter
	DJNZ Inner	;Loop until B=0
	POP BC		;POP roll counter
	DJNZ Outer	;Loop until B=0
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF
