;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Roll Up
;
; PRINT USR RUP;[Lines]
;
;================================

@DFile=400C		;Start of DFile
@PRBuff=403C		;Line storage area
@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackA=0C02		;Move results to A

@RollUp
	RST 20		;Get next character
	LD B,01		;Default lines
	LD A,75
	INC A
	CP (HL)
	JR Z Loop	;Jump if no value specified
	CALL Class6	;Evaluate [Lines] expression
	CALL StackA	;Move results to A, A=Lines
	LD B,A		;B=Lines
@Loop
	PUSH BC		;PUSH counter
;Copy row 0 to PRBuff
	LD HL,(DFile)	;Setup for LDIR
	INC HL
	LD DE,PRBuff
	LD BC,0020
	LDIR
;Roll DFile up
	LD DE,(DFile)	;Setup for LDIR
	LD BC,02F7
	LDIR
;Copy PRBuff to Row 23
	LD C,20		;Setup for LDIR
	INC DE
	LD HL,PRBuff
	LDIR
	POP BC		;POP counter
	DJNZ Loop	;Loop until B=0
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF
