;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Scroll Up
;
; PRINT USR UP;[Lines][CODE "Chr X"]
;
;================================

@DFile=400C		;Start of DFile
@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackBC=0BF5		;Move results to BC

@Up
	RST 20		;Get next character
	LD BC,0100	;Default Lines (B) & Chr (C)
	LD A,75
	INC A
	CP (HL)
	LD A,C		;A=Default Chr
	JR Z Loop	;Jump if no value specified
	CALL Class6	;Evaluate [Lines] expression 
	RST 20 		;Get next character
	CALL Class6	;Evaluate [CODE "Chr X"] expression
	CALL StackBC	;Move results to BC, B=Chr, A=C=Lines
	LD A,B		;A=Chr
	LD B,C		;B=Lines
@Loop
	PUSH BC		;PUSH counter
;Scroll DFile up
	LD HL,(DFile)	;Get DFile
	LD D,H		;Setup for LDIR
	LD E,L
	LD BC,0021
	ADD HL,BC
	LD BC,02F7
	LDIR		;Scroll up
;Erase Row 23
	LD B,20
	EX DE,HL
	INC HL
	LD (HL),A	;Fill chr
	INC HL		;Next DFile addr
	DJNZ -4		;Loop until B=0
	POP BC		;POP counter
	DJNZ Loop	;Loop until B=0
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF