;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; 	   Spiral Clear
;	   Gary Nugent
;	     YC-8211
;
; PRINT USR SPIR;[Speed],[CODE "Chr X"]
;
;================================

@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackBC=0BF5		;Move results to BC
@DFile=400C		;Start of DFile
@BUFF1=403C		;Speed value, IY+60

@Fill
	RST 20		;Get next character
	LD B,00		;Default chr
	LD A,75
	INC A
	CP (HL)
	LD A,01		;Default speed
	JR Z Spiral	;Jump if no value specified
	CALL Class6	;Evaluate [Speed] expression
	RST 20 		;Get next character
	CALL Class6	;Evaluate [CODE "Chr X"] expression
	CALL StackBC	;Move results to BC, B=Chr, A=C=Speed
@Spiral
	LD (IY+60),A	;Store speed
	LD A,B	 	;Fill chr
	LD HL,(DFile)
	LD C,17 	;Rows to clear, 21 
	LD B,20 	;Columns to clear, 32
@Loop
	LD D,B		;
@Right
	INC HL 
	LD (HL),A 
;Pause1
	LD E,B
	LD B,(IY+60)
	DJNZ -2
	LD B,E
	DEC D 
	JR NZ Right
	DEC B 
	LD E,C 
	PUSH BC 
	LD BC,0021 
@Down
	ADD HL,BC 
	LD (HL),A 
;Pause2
	LD B,(IY+60)
	DJNZ -2
	DEC E 
	JR NZ Down
	POP BC 
	DEC C 
	LD D,B 
@Left
	DEC HL 
	LD (HL),A 
;Pause3
	LD E,B
	LD B,(IY+60)
	DJNZ -2
	LD B,E
	DEC D 
	JR NZ Left
	LD E,A 
	LD A,B 
	CP 09
	JR Z Done
	LD A,E 
	DEC B 
	LD E,C 
	PUSH BC 
	LD BC,0021 
@Up
	SBC HL,BC 
	LD (HL),A 
;Pause4
	LD B,(IY+60)
	DJNZ -2
	DEC E 
	JR NZ Up
	POP BC 
	DEC C 
	JR Loop
@Done
	RST 08
	FF