;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Swap Chr A and Chr B
;
; PRINT USR SWAP;[CODE "Chr A"],[CODE "Chr B"]
;
;================================

@DFile=400C		;Start of DFile
@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackBC=0BF5		;Move results to BC

@Swap
	RST 20		;Get next character
	CALL Class6	;Evaluate [CODE "Chr A"] expression
	RST 20 		;Get next character
	CALL Class6	;Evaluate [CODE "Chr B"] expression
	CALL StackBC	;Move results to BC, B=Chr B, A=C=Chr A
	LD D,C		;D=Chr. A
	LD E,B		;E=Chr. B
	LD HL,(DFile)	;Get DFile
	LD BC,0319	;DFile size
@Loop
	LD A,(HL)	;Get chr
	CP D		;Chr A?
	JR NZ +3	;Jump if not Chr A
	LD A,E		;Set reg A to Chr B
	JR +4
	CP E		;Chr B?
	JR NZ +2	;Jump if not Chr B
	LD A,D		;Set reg A to Chr A
	LD (HL),A	;Replace
	INC HL		;Next DFile addr
	DEC BC		;Decrease counter
	LD A,B 
	OR C 
	JR NZ Loop	;Loop until BC=0
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF