;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Draw Horizontal Lines
;
; PRINT USR HLIN;[Ycoord][Xcoord][Length][CODE "Chr X"]
;
;================================

@DFile=400C		;Start of DFile
@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackBC=0BF5		;Move results to BC
@CHAdd=4016

@HLin
	RST 20		;Get next character
	CALL Class6	;Evaluate [Ycoord] expression
	RST 20 		;Get next character
	CALL Class6	;Evaluate [Xcoord] expression
	CALL StackBC	;Move results to BC, B=Xcoord, A=C=Ycoord
	PUSH BC		;PUSH XYcoords
	RST 20		;Get next character
	CALL Class6	;Evaluate [Length] expression
	RST 20 		;Get next character
	CALL Class6	;Evaluate [CODE "Chr X"] expression
	CALL StackBC	;Move results to BC, B=Chr code, A=C=Length
	LD HL,(DFile)	;Get DFile
	INC HL
	POP DE		;POP XYCoords, D=Xcoord, E=Ycoord
	PUSH BC		;PUSH Chr Code/Length
	LD B,E		;B=Ycoord
	LD C,D		;C=XCoord
	LD A,B		;Test Ycoord
	AND A		;0?
	JR Z AddX	;Jump if Ycoord=0
	LD DE,0021	;Bytes/row
@AddY
	ADD HL,DE	;Add row offset
	DJNZ AddY
@AddX
	ADD HL,BC	;Add column offset
	POP DE		;D=Chr code, E=Length
	LD C,E		;BC=Length
	LD (HL),D	;Set chr to print
	DEC C
	JR Z More	;Jump if chr count=1
	LD D,H		;Setup for LDIR
	LD E,L
	INC DE
	LDIR
@More
	LD HL,(CHAdd)
	LD A,(HL)
	CP 19		;Test for ";"
	JR Z HLin
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF