;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Roll Down
;
; PRINT USR RDWN;[Lines]
;
;================================

@DFile=400C		;Start of DFile
@PRBuff=403C		;Line storage area
@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackA=0C02		;Move results to A

@RollDown
	RST 20		;Get next character
	LD B,01		;Default lines
	LD A,75
	INC A
	CP (HL)
	JR Z Loop	;Jump if no value specified
	CALL Class6	;Evaluate [Lines] expression
	CALL StackA	;Move results to A, A=Lines
	LD B,A		;B=Lines
@Loop
	PUSH BC		;PUSH counter
;Copy row 23 to PRBuff
	LD HL,(DFile)	;Setup for LDIR
	LD DE,02F8
	ADD HL,DE
	LD DE,PRBuff
	LD BC,20
	LDIR
;Roll DFile down
	EX DE,HL	;Setup for LDIR
	LD H,D
	LD L,E
	LD C,21 
	SBC HL,BC 
	LD BC,02F7 
	LDDR
;Copy PRBuff to Row 0
	LD HL,PRBuff	;Setup for LDIR
	LD DE,(DFile)
	INC DE
	LD C,20
	LDIR
	POP BC		;POP Counter
	DJNZ Loop	;Loop until BC=0
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF
