;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Roll Right
;
; PRINT USR RLFT;[Lines]
;
;================================

@DFile=400C		;Start of DFile
@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackA=0C02		;Move results to A

@RollRite
	RST 20		;Get next character
	LD B,01		;Default lines
	LD A,75
	INC A
	CP (HL)
	JR Z Outer	;Jump if no value specified
	CALL Class6	;Evaluate [Lines] expression
	CALL StackA	;Move results to A, A=Lines
	LD B,A		;B=Lines
@Outer
	PUSH BC			;PUSH roll counter
	LD HL,(DFile)		;Get DFile
	DEC HL			;Decrease so offset of BC=0021 works
	LD B,18			;Row counter
@Inner
	PUSH BC			;PUSH row counter
	LD BC,0021		;Offset to Column 31
	ADD HL,BC		;HL=Column 31 addr
	PUSH HL			;PUSH Column 31 addr
	LD A,(HL)		;Get column 31 chr
;Shift row right
	LD D,H			;Setup for LDDR
	LD E,L
	DEC DE
	EX DE,HL
	LD C,1F
	LDDR
	LD (DE),A		;Fill column 0 with column 31 chr
	POP HL			;POP Column 31 addr
	POP BC			;POP row counter
	DJNZ Inner		;Loop until row counter=0
	POP BC			;POP roll counter
	DJNZ Outer		;Loop until roll counter=0
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF
